//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2007 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef JIT_SCALAR_H
#define JIT_SCALAR_H

#ifdef _MSC_VER
	#pragma once
#endif

#include "jit.h"
#include "interp.h"

class VDShaderScalarJIT {
public:
	VDShaderScalarJIT();
	~VDShaderScalarJIT();

	void LoadSamplers(const VDShaderInterpreterSampler *samplers, int numSamplers);
	bool LoadShader(const VDShaderFunction& func, const VDShaderBindingElement *pElements, int numElements, IVDShaderLogOutput *out);

	void Execute(uint32 *dst, const VDShaderInterpreterInterpolator *interps, uint32 count) {
		mpShader(dst, interps, count);
	}

protected:
	const VDShaderInterpreterSampler *mpSamplers;

	VDShaderScalarForm	mScalarForm;
	VDJITAllocator		mAllocator;

	typedef void (__cdecl *Shader)(void *dst, const VDShaderInterpreterInterpolator *interps, uint32 count);

	Shader	mpShader;
	uint32 mShaderLen;
};

#endif
