// RGB to YCbCr
sampler src;

float4 PS(float2 uv: TEXCOORD0) : COLOR0 {
	float4 px;
	
	// Note that we are using full-range equations here, not the standard encoding
	// with headroom.
	//	
	//	Y   =     0.299  R + 0.587  G + 0.114  B
	//	Cb  =   - 0.1687 R - 0.3313 G + 0.5    B + 128
	//	Cr  =     0.5    R - 0.4187 G - 0.0813 B + 128

	float3x3 mx=float3x3(
		float3(0.5, 0.299, -0.1687),
		float3(-0.4187, 0.587, -0.3313),
		float3(-0.0813, 0.114, 0.5)
	);

	px = tex2D(src, uv);

	float3 cyc = mul(px.rgb, mx) + float3(128.0/255.0, 0, 128.0/255.0);

	return float4(cyc, px.a);
}

technique {
	pass {
		PixelShader = compile ps_3_0 PS();
	}
}
