//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2007 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef VECARITH_H
#define VECARITH_H

#ifdef _MSC_VER
	#pragma once
#endif

#include "effect.h"

VDShaderConstant operator-(const VDShaderConstant& x);
VDShaderConstant operator+(const VDShaderConstant& x, const VDShaderConstant& y);
VDShaderConstant operator-(const VDShaderConstant& x, const VDShaderConstant& y);
VDShaderConstant operator*(const VDShaderConstant& x, const VDShaderConstant& y);

VDShaderConstant& operator+=(VDShaderConstant& x, const VDShaderConstant& y);
VDShaderConstant& operator-=(VDShaderConstant& x, const VDShaderConstant& y);
VDShaderConstant& operator*=(VDShaderConstant& x, const VDShaderConstant& y);

namespace nsVDShaderArith {
	VDShaderConstant div1(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant div2(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant div3(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant div4(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant dp4(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant dp3(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant dp2(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant swizzle(const VDShaderConstant& x, unsigned char swiz);
	VDShaderConstant min(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant max(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant abs(const VDShaderConstant& x);
	VDShaderConstant cross(const VDShaderConstant& x, const VDShaderConstant& y);
	VDShaderConstant lerp(const VDShaderConstant& x, const VDShaderConstant& y, const VDShaderConstant& z);
}

#endif
